const fs = require('fs')
const path = require('path')
const {dialog,ipcMain,shell} = require('electron')
var unzip = require('node-unzip-2')
let _type=['openItem','saveItem']
let _typeArray=[];
let _saveFilepath;
const $ipconfig = require('../ipconfig')
const baseUrl = $ipconfig.fileUrl;
downListen = () => {
	  global.mainWindow.webContents.session.on('will-download', (e, item) => {
	    //获取文件的总大小
	   const totalBytes = item.getTotalBytes();
		 //path.resolve(__dirname, './downloads', item.getFilename())
	   //const filePath = path.resolve(__dirname, './files', item.getFilename())
	   var filePath;
	   var _filepath;
	   var _typeNow;
	   var _isfloder;
	   _typeArray.forEach((_item,index)=>{
	   	   if(_item.filename==item.getFilename()){
               _typeNow = _item.type;
               _isfloder= _item.isfloder;
	   	   }
	   })
	   _typeNow == 'openItem' ? filePath = path.resolve(global.localFILE, item.getFilename()):filePath = _saveFilepath;
	   if(_isfloder){
	   	    if(_typeNow == 'saveItem') _filepath=filePath;
	   	    filePath= path.resolve(baseUrl, item.getFilename())
	   }
	   item.setSavePath(filePath);
		
		//监听下载过程，计算并设置进度条进度
	   item.on('updated', () => {
	   	   var total=item.getReceivedBytes() / totalBytes;
	   	   global.mainWindow.webContents.send('downFile:downProgress',{type:'progress',filename:item.getFilename(),total:total});
	       global.mainWindow.setProgressBar(total);
	   });
		
		//监听下载结束事件
	   item.on('done', (e, state) => {
	   		//如果窗口还在的话，去掉进度条
	       if (!global.mainWindow.isDestroyed()) {
	           global.mainWindow.setProgressBar(-1);
	       }
			
			//下载被取消或中断了
	       if (state === 'interrupted') {
	           //dialog.showErrorBox('下载失败', `文件 ${item.getFilename()} 因为某些原因被中断下载`);
	           global.mainWindow.webContents.send('downFile:downProgress',{type:'error',filename:item.getFilename(),errmsg:`文件 ${item.getFilename()} 已被删除`});
	       }
			
			//下载完成
	       if (state === 'completed') {
	           if(_typeNow == 'openItem'){
	           	   //区别文件夹
	           	   if(_isfloder){
	           	   	   var nowpath;
	           	   	   _filepath ? nowpath=_filepath : nowpath=path.resolve(global.localFILE, item.getFilename().split('.zip')[0])
                       var stream=fs.createReadStream(filePath)
                                    .pipe(unzip.Extract({ path: nowpath }));
           	           stream.on('finish',function(){
                           shell.openItem(nowpath)                          
                           fs.unlink(filePath,function (err) {
					            if(err) throw err;
					            console.log('success')
					       })
           	           })
           	           global.mainWindow.webContents.send('downFile:downProgress',{type:'finish',filename:item.getFilename()});
	           	   }else{
	           	       shell.openItem(filePath)
	           	       global.mainWindow.webContents.send('downFile:downProgress',{type:'finish',filename:item.getFilename()});
	           	   }
	           }else{
	           	 	//区别文件夹
	           	   if(_isfloder){
	           	   	   var nowpath;
	           	   	   _filepath ? nowpath=_filepath : nowpath=path.resolve(global.localFILE, item.getFilename().split('.zip')[0])
                       var stream=fs.createReadStream(filePath)
                                    .pipe(unzip.Extract({ path: nowpath }));
           	           stream.on('finish',function(){                         
                           fs.unlink(filePath,function (err) {
					            if(err) throw err;
					            console.log('success')
					       })
           	           })
           	           global.mainWindow.webContents.send('downFile:downProgress',{type:'finish',filename:item.getFilename()});
	           	   }else{
	           	       shell.openItem(filePath)
	           	       global.mainWindow.webContents.send('downFile:downProgress',{type:'finish',filename:item.getFilename()});
	           	   }  
	           }
	       }
	       _typeArray.splice(_typeArray.findIndex(_item => _item.filename==item.getFilename()), 1)
	   });
	});
}
openFile = (filename,downloadpath,type) =>{
	var _filename;
	type=='folder' ? _filename=filename.split('.zip')[0]:_filename=filename;
    const filePath = path.resolve(global.localFILE, _filename)
    fs.exists(filePath, function(exists) { 
    	if(exists){
            shell.openItem(filePath);
    	}else{
    		var isfloder=false;
    		console.log(filename,type,downloadpath)
    		if(type=='folder') isfloder=true;
    		_typeArray.push({
                filename:filename,
                type:_type[0],
                isfloder:isfloder
    		})
    		global.mainWindow.webContents.downloadURL(downloadpath);
    	}
	});
}
saveFile = (filename,downloadpath,type) => {
	var _filename;
	var _filt;
	type=='folder' ? _filename=filename.split('.zip')[0]:_filename=filename;
	if(type=='folder'){
		_filename=filename.split('.zip')[0];
		_filt='*';
	}else{
		_filename=filename;
		_filt=filename.substring(filename.lastIndexOf('.')+1);
	}
	const options = {
	    title: '保存文件',
	    defaultPath : _filename,
	    filters: [
	      { name: '文件', extensions: [_filt] }
	    ],
	    properties:['openDirectory']
	}
	dialog.showSaveDialog(options, function (res) {
	    console.log(res)
	    if(res){
	    	var isfloder=false;
    		console.log(filename,type,downloadpath)
    		if(type=='folder') isfloder=true;
    		_typeArray.push({
                filename:filename,
                type:_type[1],
                isfloder:isfloder
    		})
            global.mainWindow.webContents.downloadURL(downloadpath);
            _saveFilepath=res;
	    }
	})
}
openFolder = (filename,type) => {
	var _filename;
	type=='folder' ? _filename=filename.split('.zip')[0]:_filename=filename;
    const filePath = path.resolve(global.localFILE, _filename)
    fs.exists(filePath, function(exists) { 
    	if(exists){
    		type=='folder' ?  shell.openItem(filePath):shell.showItemInFolder(filePath)
    	} else {
    		global.mainWindow.webContents.send('file:notfound');
    	}
    })	
}
ipcMain.on('downFile:openFile', (event, arg) => {
    openFile(arg.filename,arg.downloadpath,arg.type);
})
ipcMain.on('downFile:saveFile', (event, arg) => {
    saveFile(arg.filename,arg.downloadpath,arg.type);
})
ipcMain.on('downFile:openFolder', (event, arg) => {
    openFolder(arg.filename,arg.type);
})
module.exports = {   
    "downListen" :downListen,
    "openFile": openFile 
};

