const path = require('path')
const fs = require('fs')

const request = require('request');
const $ipconfig = require('../ipconfig')
const baseFileUrl = $ipconfig.baseFileUrl;
const topfileUrl = baseFileUrl+"/update.asar";
// ---- 下载类 ---- //
//function StreamDownload() {
  // 声明下载过程回调函数
//  this.downloadCallback = null;
//}
const StreamDownload = {downloadCallback:null,showProgress:null,downloadFile:null};
//const StreamDownload = new StreamObejct();

// 下载进度
StreamDownload.showProgress = function (received, total) {
  const percentage = (received * 100) / total;
  // 用回调显示到界面上
  this.downloadCallback('progress', percentage);
};

// 下载过程
StreamDownload.downloadFile = function (patchUrl,callback) {

  this.downloadCallback = callback; // 注册回调函数

  //const downloadFileName = 'update.7z'; // 下载文件名称，也可以从外部传进来

  let receivedBytes = 0;
  let totalBytes = 0;

  const req = request({
    method: 'GET',
    uri: patchUrl
  });
  process.noAsar = true
  const out = fs.createWriteStream(topfileUrl);
  req.pipe(out);

  req.on('response', (data) => {
    // 更新总文件字节大小
    totalBytes = parseInt(data.headers['content-length'], 10);
  });

  req.on('data', (chunk) => {
    // 更新下载的文件块字节大小
    receivedBytes += chunk.length;
    this.showProgress(receivedBytes, totalBytes);
  });

  req.on('end', () => {
    console.log('下载已完成，等待处理');
    process.noAsar = false;
    // TODO: 检查文件，部署文件，删除文件
    this.downloadCallback('finished', '100');
  });
};

//const StreamDownload = new StreamDownload();
module.exports = {  
  "StreamDownload":StreamDownload
}
