const electron = require('electron')
const pagejson = require('../package.json')
const { ipcMain } = electron
const fs = require('fs')
const Datastore = require('nedb')
const os = require('os')
const userInfo = os.userInfo()
const baseUrl = userInfo.homedir+'/.local/share/';
const fileUrl = userInfo.homedir+'/Documents/';
const baseFileUrl = baseUrl+pagejson.build.appId
console.log(baseFileUrl)
ipcMain.on("Login:ipconfig", (event, args) => {
    global.oaURL=args.oaURL
    global.localURL=args.localURL
	global.data_db.update({
	  id:1
	}, {
	  $set: {
	    localURL: args.localURL,
	    oaURL:args.oaURL
	  }
	}, (err, ret) => {});
})
module.exports = {
  "baseUrl":baseUrl,
  "baseFileUrl":baseFileUrl,
  "fileUrl":fileUrl
}



