const electron = require('electron')
const { ipcMain } = electron;
const notifier = require('node-notifier')
const path = require('path')
const $tray = require(path.resolve(__dirname, '../tray'))
addnotify = (arg) => {
    $tray.clearTray()
    if (global.mainWindow.isMinimized()) global.mainWindow.restore()
    global.mainWindow.show()
}
notifyListen = () => {
  ipcMain.on('NOTIFY:addTray',(event,arg)=>{
      $tray.addTray();
  })
  // notify发送
  ipcMain.on('NOTIFY:notify',(event,arg)=>{
      global.mainWindow.flashFrame(true);
  })
  ipcMain.on('NOTIFY:click',(event,arg)=>{
      addnotify();
  })
}
module.exports = notifyListen
