const electron = require('electron')
const { ipcMain,dialog } = electron;
const path = require('path');
const fs = require('fs');
const archiver = require('archiver');
const $ipconfig = require('../ipconfig')
const baseUrl = $ipconfig.baseUrl;
const baseFileUrl = $ipconfig.fileUrl;
const floderLocal = baseFileUrl+'/floder_jwchat';
const request = require('request');
fs.exists(floderLocal,function(exists){
   if(!exists){  
    fs.exists(baseFileUrl,function(exists){
       if(!exists){  
          fs.mkdir(baseFileUrl,function(){
             fs.mkdir(floderLocal,function(){});
          });
       }else{
          fs.mkdir(floderLocal,function(){});
       }
    })
   }
})
addFolder = (Floderurl,uploadURL,filename,userFrom,userTo,msgMf) => {
   var FloderPath = path.resolve(floderLocal, filename);
   var output = fs.createWriteStream(FloderPath);
   var archive = archiver('zip', {
      zlib: { level: 9 } // Sets the compression level.
   });
   output.on('close', function() {
      console.log(archive.pointer() + ' total bytes');
      var file_size=(archive.pointer()/1024).toFixed(2)+'K';
      if(parseInt(file_size)>1024){
          file_size=(parseInt(file_size)/1024).toFixed(2)+'M';
          if(parseInt(file_size)>200){
            global.mainWindow.webContents.send('PASTE:Progress',{type:'paste',status:'error',msgMf:msgMf,size:file_size})
            fs.unlink(FloderPath,function (err) {
              if(err) throw err;
              console.log('success')
             })
            return;
          }
      }
      global.mainWindow.webContents.send('PASTE:Progress',{type:'paste',status:'success',msgMf:msgMf,size:file_size})
      var req = request.post(uploadURL, function (err, resp, body) {
          if (err) {
              global.mainWindow.webContents.send('PASTE:Progress',{type:'upload',status:'fail',msg:err,msgMf:msgMf,size:file_size})
          } else {
              console.log(body);
              global.mainWindow.webContents.send('PASTE:Progress',{type:'upload',status:'success',msg:body,msgMf:msgMf,size:file_size})
          }
          fs.unlink(FloderPath,function (err) {
              if(err) throw err;
              console.log('success')
          })
      });

      var form = req.form();

      form.append('file', fs.createReadStream(FloderPath), {
          filename: filename,
          contentType: 'application/zip'
      });
      form.append('userFrom',userFrom);
      form.append('userTo',userTo);
      form.append('isFolder',1)
   });

   output.on('end', function() {
      console.log('Data has been drained');
   });

   archive.on('warning', function(err) {
      global.mainWindow.webContents.send('PASTE:Progress',{type:'paste',status:'fail',msgMf:msgMf})
      if (err.code === 'ENOENT') {
        // log warning
      } else {
        // throw error
        throw err;
      }
   });

   archive.on('error', function(err) {
      global.mainWindow.webContents.send('PASTE:Progress',{type:'paste',status:'fail',msgMf:msgMf})
      throw err;
   });
   archive.pipe(output);

   archive.directory(Floderurl, false);

   archive.finalize();
}
uploadFile = (Floderurl,uploadURL,filename,userFrom,userTo,msgMf) => {
	  var req = request.post(uploadURL, function (err, resp, body) {
	      if (err) {
	          global.mainWindow.webContents.send('Main:Progress',{type:'upload',status:'fail',msg:err,msgMf:msgMf})
	      } else {
	          console.log(body);
	          global.mainWindow.webContents.send('Main:Progress',{type:'upload',status:'success',msg:body,msgMf:msgMf})
	      }
	  });

	  var form = req.form();
	  form.append('file', fs.createReadStream(Floderurl), {
	      filename: filename,
	      contentType: ''
	  });
	  form.append('userFrom',userFrom);
	  form.append('userTo',userTo);
}
pasteListen = () => {
  ipcMain.on('PASTE:addFolder',(event,arg)=>{
      addFolder(arg.Floderurl,arg.uploadURL,arg.filename,arg.userFrom,arg.userTo,arg.msgMf)
  })
  ipcMain.on('Main:uploadFile',(event,arg)=>{
  	  uploadFile(arg.Floderurl,arg.uploadURL,arg.filename,arg.userFrom,arg.userTo,arg.msgMf)
  })
  // notify发送
  ipcMain.on('PASTE:removeFolder',(event,arg)=>{
  })
  // 打开文件夹
  ipcMain.on("Main:chooseFolder",(event,args)=>{
      if(global.localFILE==""||typeof(global.localFILE)=="object"){
           global.localFILE = baseFileUrl
      }
      const options = {
          title: '选择文件存储位置',
          defaultPath : global.localFILE,
          filters: [
            { name: 'All Files', extensions: ['*'] }
          ],
          properties:['openDirectory']
      }
      dialog.showOpenDialog(options, function (res) {
          if(res){
              global.localFILE=res[0]
              global.data_db.update({
                id:1
              }, {
                $set: {
                  localFILE: res[0]
                }
              }, (err, ret) => {});
              global.mainWindow.webContents.send('Main:folderpath',{path:res[0]})
          }       
      }) 
  }) 
}
ipcMain.on('PASTE:isFolder',(event,arg)=>{
    fs.exists(arg.path,function(exists){
       if(exists){
          var stat = fs.lstatSync(arg.path);
          event.returnValue = stat.isDirectory();
       }else{
          event.returnValue = false;
       }
    })
})
ipcMain.on('PASTE:isFile',(event,arg)=>{
    fs.exists(arg.path,function(exists){
       if(exists){
          event.returnValue = true;
       }else{
          event.returnValue = false;
       }
    })
})
ipcMain.on('PASTE:getSize',(event,arg)=>{
    fs.exists(arg.path,function(exists){
       if(exists){
          fs.stat(arg.path,function(err,stats){
               console.log(stats)
               var file_size=(stats.size/1024).toFixed(2)+'K';
               if(parseInt(file_size)>1024){
		          file_size=(parseInt(file_size)/1024).toFixed(2)+'M';
		          if(parseInt(file_size)>1024){
		            event.returnValue ={type:1}
		            return;
		          }
		      }
		      event.returnValue ={type:2,file_size:file_size}
          })
       }else{
          event.returnValue ={type:0};
       }
    })
})
module.exports = {
  "pasteListen":pasteListen
}

