const electron = require('electron')
const { app,ipcMain } = electron;
const path = require('path')
const StreamDownload = require('./StreamDownload').StreamDownload;
const $ipconfig = require('../ipconfig')
const baseFileUrl = $ipconfig.baseFileUrl;
const topfileUrl = baseFileUrl+"/app.asar";
const copy = require('./copyFile').copyFile;
var unzip = require('node-unzip-2')
var http = require("http");   
var data = {getVersion:"hello"};  
var fs= require('fs')
data = JSON.stringify(data);  
var body = '';  
updateHandle = () => {
    var opturl=global.localURL.split('http://')[1].split(':')[0];
    var optport=global.localURL.split('http://')[1].split(':')[1];  
	var opt = {  
		host:opturl,  
		port:optport,  
		method:'get',  
		path:'/mongoFun/getEversion',  
		headers:{  
		    "Content-Type": 'application/json',  
		    "Content-Length": data.length  
		}  
	} 
	var req = http.request(opt, function(res) {  
		res.on('data',function(data){  
		    body += data; 
		}).on('end', function(){
            try{
				const jsondata = JSON.parse(body); 
				const nowVersion=jsondata.returndata[0].version;
				if(nowVersion!=global.version){
				   sendUpdateMessage({type:'updateAva'})
				}else{
				   sendUpdateMessage({type:'updateNotAva'})
				}
            } catch (err){}
		});  
	}).on('error', function(e) {  
		console.log("error: " + e.message);  
	})  
	req.write(data);  
	req.end();  
}
//监听渲染线程中用户是否同意下载
ipcMain.on("isDownload", () => {
    // 调用下载
    StreamDownload.downloadFile(global.localURL+'/update.asar', downloadFileCallback)
})
//监听用户安装
ipcMain.on('isUpdate', (e, arg) => {
    //some code here to handle event 文件复制
	process.noAsar = true
	let file = fs.createReadStream(baseFileUrl+"/update.asar");
	let out = fs.createWriteStream(path.resolve(__dirname, '../../update.asar'));
	file.on('end',function () {
		process.noAsar = false;
		fs.unlink(path.resolve(__dirname, '../../app.asar'),function (err) {
		    if(err) throw err;
		    fs.rename(path.resolve(__dirname, '../../update.asar'),path.resolve(__dirname, '../../app.asar'),(error) => {
			  if (error) {
				console.log(error);
			  } else {
				console.log('--update finish--restarting--');
                app.relaunch()
                app.exit(0)
			  }
			});
		})
	})
	file.on('error',function(err){console.log(err)})
	file.pipe(out);
})
sendUpdateMessage = text => {
    console.log(text)
    global.mainWindow.webContents.send('updateCh', text)
}

//下载测试
// 定义回调函数
function downloadFileCallback(arg, percentage)
{
    if (arg === "progress")
    {
        // 显示进度
       progressObj={percent:percentage}
       sendUpdateMessage({type:'progress',data:progressObj})
    }
    else if (arg === "finished")
    {
        // 通知完成
        console.log(percentage)
       sendUpdateMessage({type:'isUpdateNow'})
    }
}
module.exports = {
   "updateHandle" : updateHandle
}
